###
## Controls 
##
##	Create two sets of control widgets.
##
##	The first widget controls the inter-arrival times
##	of cars arriving at the lights.
##
##	The second widget controls the length of the lights.
##

proc draw_controls {} {
#  light_controls   .traffic.i 4c  7c 
}

###
## light_controls
##
##	Given an object name and (x,y) coordinates,
##	build and display a set of controls, one per
##	parameter.
##	
##	The parameters are the VHDL signals that 
##	determine the length of each light (red, yellow, green).
##
 
proc light_controls {w x y} {

  catch {destroy $w.light_controls}

  frame $w.light_controls
  catch {destroy $w.light_controls2}

  frame $w.light_controls2
  
  # East/West light controls
  
  scale $w.light_controls.ew_g \
	-label "east/west green time" \
        -from 1 -to 100 \
	-length 6c \
	-orient horizontal \
        -command "set_time_variable /ew_green_time" 
  scale $w.light_controls.ns_g \
	-label "north/south green time" \
        -from 1 -to 100 \
	-length 6c \
	-orient horizontal \
        -command "set_time_variable /ns_green_time" \
	
  $w.light_controls.ew_g set 5
  $w.light_controls.ns_g set 5
  pack $w.light_controls.ew_g  -side top
  pack $w.light_controls.ns_g -side top  
      
 # Don't forget to PACK your widget!

  # Also, don't forget to initialize the slider. Try 40.


  scale $w.light_controls2.ns_y \
	-label "yellow time" \
        -from 1 -to 30 \
	-length 6c \
	-orient horizontal \
	-command "set_yellow_time" 

    
  scale $w.light_controls2.turn_g \
	-label "turn green time" \
        -from 1 -to 100 \
	-length 6c \
	-orient horizontal \
        -command "set_time_variable /left_green_time" 

  $w.light_controls2.turn_g set  5
  pack $w.light_controls2.turn_g -side top
  $w.light_controls2.ns_y set  2
  pack $w.light_controls2.ns_y -side top



  
  # Red light control
  
  scale $w.light_controls2.b_r \
	-label "both red time" \
        -from 1 -to 10 \
	-length 6c \
	-orient horizontal \
        -command "set_time_variable /all_red_time" 
  $w.light_controls2.b_r  set  1
  pack $w.light_controls2.b_r -side top
#   place $w.light_controls2.turn_y  -anchor se

  $w.c create window $x $y -window $w.light_controls
  $w.c create window $x 18c -window $w.light_controls2
 
}
 

proc set_yellow_time { val } {

set_time_variable /ew_yellow_time $val
set_time_variable /ns_yellow_time $val
set_time_variable /turn_yellow_time $val

}

###
## set_time_variable
##
##	Given a VHDL time signal and an integer value,
##	force it to nanoseconds.
##
proc set_time_variable {var val} {

  force -freeze $var $val ms

}



light_controls   .traffic.i 4c  3.75c









