
###
## connect_lights
##
##	When a signal changes in the simulation,
##	change the stop light display.
##
#
proc set_lights {sig sigval} {

#	if { ![winfo exists .traffic] } {
	#	puts "Better load the intersection!"
	#}

        #
        # connect light_ew events to the gui
        #
	# Decode the bits of light_ew 
	#	001 = green
	#	010 = yellow
	#	100 = red
	#

	# When the /light_ew signal changes, evaluate
	# this Tcl body.
	# Specifically, test the value of the /light_ew 
	# signal. Set the display light depending on the
	# state of the signal.


	# just to make sure everything is 'unique', I append ll to every signal
	   append sig ll

  switch $sig  {

        light_ewll {	  	 
          if {$sigval == 001} { 
            set_light_state green .traffic.i.ew_light_e 
          } 
          if {$sigval == 010} {
            set_light_state yellow .traffic.i.ew_light_e
          }
          if {$sigval == 100} {
            set_light_state red .traffic.i.ew_light_e
          } 
        }
        light_ew_turnll {
          if {$sigval == 001} {
            set_light_state green .traffic.i.e_turn_light
          }
          if {$sigval == 010} {
            set_light_state yellow .traffic.i.e_turn_light
          }
          if {$sigval == 100} {
            set_light_state red .traffic.i.e_turn_light
          }
        }  

        light_well {
          if {$sigval == 001} {
            set_light_state green .traffic.i.ew_light_w
          }
          if {$sigval == 010} {
            set_light_state yellow .traffic.i.ew_light_w
          }
          if {$sigval == 100} {
            set_light_state red .traffic.i.ew_light_w
          }
        }  
        light_we_turnll {
          if {$sigval == 001} {
            set_light_state green .traffic.i.w_turn_light
          }
          if {$sigval == 010} {
            set_light_state yellow .traffic.i.w_turn_light
          }
          if {$sigval == 100} {
            set_light_state red .traffic.i.w_turn_light
          }
        }

	# Add the "ns" when statements similar to the "ew"
	# above.

	light_nsll { 
          if {$sigval == 001} { 
            set_light_state green .traffic.i.ns_light_s 
            set_light_state green .traffic.i.ns_light_n 
          } 
          if {$sigval == 010} {
            set_light_state yellow .traffic.i.ns_light_s
            set_light_state yellow .traffic.i.ns_light_n
          }
          if {$sigval == 100} {
            set_light_state red .traffic.i.ns_light_s
            set_light_state red .traffic.i.ns_light_n
          } 
        }
	default {
		debug invalid $sig$sigval
	}
  }

}














